"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import pydantic
from pydantic import model_serializer
from ttd_workflows.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from typing_extensions import Annotated, NotRequired, TypedDict


class CampaignCreateROIGoalInputTypedDict(TypedDict):
    maximize_reach: NotRequired[Nullable[bool]]
    r"""Reach as many unique users as possible in your intended audience."""
    maximize_ltv_incremental_reach: NotRequired[Nullable[bool]]
    r"""The goal is to reach as many users as possible beyond those who have already reached on Linear TV."""
    cpc_in_advertiser_currency: NotRequired[Nullable[float]]
    r"""The Cost Per Click goal (in the Advertiser currency)."""
    ctr_in_percent: NotRequired[Nullable[float]]
    r"""The Click Through Rate goal (in percent), for example, 1 = 1% (1 in 100)."""
    nielsen_otp_in_percent: NotRequired[Nullable[float]]
    r"""The Nielsen On Target Percentage goal (in percent), for example, 1 = 1% (1 in 100)."""
    cpa_in_advertiser_currency: NotRequired[Nullable[float]]
    r"""The Cost Per Acquisition goal (in the Advertiser currency)."""
    return_on_ad_spend_percent: NotRequired[Nullable[float]]
    r"""The Return on Ad Spend goal (in percent of ad spend)."""
    vcr_in_percent: NotRequired[Nullable[float]]
    r"""The Video Completion Rate goal (in percent), for example, 1 = 1% (1 in 100)."""
    viewability_in_percent: NotRequired[Nullable[float]]
    r"""The Viewability goal (in percent), for example, 1 = 1% (1 in 100)."""
    vcpm_in_advertiser_currency: NotRequired[Nullable[float]]
    r"""The Estimated Viewable Cost Per Mille (thousand) goal (in the Advertiser currency)."""
    cpcv_in_advertiser_currency: NotRequired[Nullable[float]]
    r"""Cost Per Completed View goal (in the Advertiser currency)."""


class CampaignCreateROIGoalInput(BaseModel):
    maximize_reach: Annotated[
        OptionalNullable[bool], pydantic.Field(alias="maximizeReach")
    ] = UNSET
    r"""Reach as many unique users as possible in your intended audience."""

    maximize_ltv_incremental_reach: Annotated[
        OptionalNullable[bool], pydantic.Field(alias="maximizeLtvIncrementalReach")
    ] = UNSET
    r"""The goal is to reach as many users as possible beyond those who have already reached on Linear TV."""

    cpc_in_advertiser_currency: Annotated[
        OptionalNullable[float], pydantic.Field(alias="cpcInAdvertiserCurrency")
    ] = UNSET
    r"""The Cost Per Click goal (in the Advertiser currency)."""

    ctr_in_percent: Annotated[
        OptionalNullable[float], pydantic.Field(alias="ctrInPercent")
    ] = UNSET
    r"""The Click Through Rate goal (in percent), for example, 1 = 1% (1 in 100)."""

    nielsen_otp_in_percent: Annotated[
        OptionalNullable[float], pydantic.Field(alias="nielsenOTPInPercent")
    ] = UNSET
    r"""The Nielsen On Target Percentage goal (in percent), for example, 1 = 1% (1 in 100)."""

    cpa_in_advertiser_currency: Annotated[
        OptionalNullable[float], pydantic.Field(alias="cpaInAdvertiserCurrency")
    ] = UNSET
    r"""The Cost Per Acquisition goal (in the Advertiser currency)."""

    return_on_ad_spend_percent: Annotated[
        OptionalNullable[float], pydantic.Field(alias="returnOnAdSpendPercent")
    ] = UNSET
    r"""The Return on Ad Spend goal (in percent of ad spend)."""

    vcr_in_percent: Annotated[
        OptionalNullable[float], pydantic.Field(alias="vcrInPercent")
    ] = UNSET
    r"""The Video Completion Rate goal (in percent), for example, 1 = 1% (1 in 100)."""

    viewability_in_percent: Annotated[
        OptionalNullable[float], pydantic.Field(alias="viewabilityInPercent")
    ] = UNSET
    r"""The Viewability goal (in percent), for example, 1 = 1% (1 in 100)."""

    vcpm_in_advertiser_currency: Annotated[
        OptionalNullable[float], pydantic.Field(alias="vcpmInAdvertiserCurrency")
    ] = UNSET
    r"""The Estimated Viewable Cost Per Mille (thousand) goal (in the Advertiser currency)."""

    cpcv_in_advertiser_currency: Annotated[
        OptionalNullable[float], pydantic.Field(alias="cpcvInAdvertiserCurrency")
    ] = UNSET
    r"""Cost Per Completed View goal (in the Advertiser currency)."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "maximizeReach",
            "maximizeLtvIncrementalReach",
            "cpcInAdvertiserCurrency",
            "ctrInPercent",
            "nielsenOTPInPercent",
            "cpaInAdvertiserCurrency",
            "returnOnAdSpendPercent",
            "vcrInPercent",
            "viewabilityInPercent",
            "vcpmInAdvertiserCurrency",
            "cpcvInAdvertiserCurrency",
        ]
        nullable_fields = [
            "maximizeReach",
            "maximizeLtvIncrementalReach",
            "cpcInAdvertiserCurrency",
            "ctrInPercent",
            "nielsenOTPInPercent",
            "cpaInAdvertiserCurrency",
            "returnOnAdSpendPercent",
            "vcrInPercent",
            "viewabilityInPercent",
            "vcpmInAdvertiserCurrency",
            "cpcvInAdvertiserCurrency",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
